

module Matrices
    class Matrices
        include Enumerable,Comparable
        attr_reader :m, :n, :datos
        def initialize(m=1,n=1,opcion=0)
            @m,@n = m,n
            @datos = Array.new(m)
                for i in 0...@n do
                    @datos[i] = Array.new(@n)
                end
            if (opcion == 1)
            #Rellenamos la matriz con valores aletarios
                setRandom
            else
                for i in 0...opcion.size do
                    @datos[i] = opcion[i]
                end
            end
            #Imprimimos la matriz
            puts(self)
        end
        #Metodo que inicia la matriz con valores aleatorios
        def setRandom
            for i in 0...@m do
             for j in 0...@n do
                @datos[i][j] = rand(100)
             end
            end
        end
        #Overwritting del metodo each
        def each
            for i in 0...@m do
             for j in 0...@n do
                yield @datos[i][j]
             end
            end
        end
        #Overwritting del metodo <=> para el modulo Comparable
        def <=>(other)
            return (@m <=> other.m) && (@n <=> other.n)
        end
        #Overwritting del metodo to_s
        def to_s
            resultado = "[ "
            for i in 0...@m do
             for j in 0...@n do
               resultado << "  #{@datos[i][j]}  "
             end
            end
            resultado << " ]"
            resultado
        end
    end
end